#ifndef FLOW_SIZING_H
#define FLOW_SIZING_H

#include "dual_sizing.h"

// line search along feasible direction
class flow_sizing : public dual_sizing
{
public:
	flow_sizing();

protected:
	double compute_max_w() const;
	virtual bool find_next_flow(int round);

	bool line_search();
	bool line_search_inexact();
	
	double step_;
	double s_;
	double epsi_;
	double alpha_;

	bool inexact_;
	bool autostep_;

}; // class flow_sizing

// pure trust region
class flow_sizing_tr : public dual_sizing
{
public:
	flow_sizing_tr();

protected:
	virtual bool find_next_flow(int round);

	bool trust_region_search();
	
	double s_;
	double expand_;
	double shrink_;

}; // class flow_sizing_tr

#endif // FLOW_SIZING_H
