#include "nr3.h"
#include "mins.h"
#include <math.h>

inline double 
power(int x, int p) {
  double ret = 1.0;
  if ( p > 0 ) {
    do {
      ret *= x;
      p--;
    } while (p != 0);
  } else {
    do{
      ret /= x;
      p++;
    } while (p != 0);
  }
  return ret;
}

struct Funcd {
  Doub operator() (const Doub x) {
    double ret = 4.610185e+01*(1/x) + 8.164157e+01 + 3.469653e+01*x + 9.326840e-01*x*x;
    return ret;
  }
  
  Doub df (const Doub x) {
    double ret = -4.610185e+01*(1/x)*(1/x) + 3.469653e+01 + 1.865368e+00*x;
    return ret;
  }
};
  
int main(int argc, char * argv)
{
  Dbrent dbrent;
  Funcd f;
  dbrent.bracket(0,100,f);
  double xmin = dbrent.minimize(f);
  printf("Minimum : %e, fmin : %e\n",xmin, dbrent.fmin);
#if 0
  printf(" 2 ^ {4} : %e , 2^{-4} : %e\n", power(2,4), power(2,-4));
#endif
  
#if 1
  printf(" Using pow 2 ^ {4} : %e , 2^{-4} : %e\n", pow(2.0,4.0), pow(2.0,-4.0));
#endif
}
